class Block {
  Block_check block_check = new Block_check();

  void move_block() { 
    if (block_check.check_block_down()) {
      block_gc_y++;
      for (y=H; y>0; y--) {
        for (x=W; x>0; x--) {
          if (field[y][x]==2) {
            field[y+1][x]=2;
            number[y+1][x] = number[y][x]; //+
            field[y][x]=1;
            number[y][x] = 0; //+
          }
        }
      }
    } else {
      field_c.draw_field();
      lock_block();
    }
  }

  void move_block_down() { 
    boolean flag=false;
    if (block_check.check_block_down()) {
      for (y=0; y<H+2; y++) {
        for (x=0; x<W+2; x++) {
          if (field[y][x]==2) {
            flag=true;
            break;
          }
        }
        if (flag)break;
      }
      block_gc_y++;
      for (y=H; y>0; y--) {
        for (x=W; x>0; x--) {
          if (field[y][x]==2) {
            field[y+1][x]=2;
            number[y+1][x] = number[y][x]; //+
            field[y][x]=1;
            number[y][x] = 0; //+
          }
        }
      }
    }
  }

  void move_block_right() { 
    if (block_check.check_block_right()) {
      block_gc_x++;
      for (y=H; y>0; y--) {
        for (x=W; x>0; x--) {
          if (field[y][x]==2) {
            field[y][x+1]=2;
            number[y][x+1] = number[y][x];  //+
            field[y][x]=1;
            number[y][x] = 0;
          }
        }
      }
    }
  }

  void move_block_left() {
    if (block_check.check_block_left()) {
      block_gc_x--;
      for (y=H; y>0; y--) {
        for (x=1; x<W+1; x++) {
          if (field[y][x]==2) {
            field[y][x]=1;
            number[y][x-1] = number[y][x]; //+
            field[y][x-1]=2;
            number[y][x] = 0; //+
          }
        }
      }
    }
  }

  void lock_block() {
    for (y=0; y<H+2; y++) {
      for (x=0; x<W+2; x++) {
        if (field[y][x]==2) {
          field[y][x]=3;
        }
      }
    }
    int k = H * W;
    while (k>0) {
      for (y=H; y>0; y--) {
        for (x=W; x>0; x--) {
          if (field[y][x]==3 && field[y+1][x]==1) {                //change+ 7/20
            field[y+1][x]=3;
            number[y+1][x] = number[y][x]; //+
            field[y][x]=1;
            number[y][x] = 0; //+
          }
        }
      }
      k--;
    }
  }

  void turn_block() {
    int[][] block_buf=new int [3][3];
    int[][] block_buf_num = new int[3][3];  //+
    int[] dx = {
      0, -1, -1, -1, 0, 1, 1, 1
    };         //+
    int[] dy = {
      -1, -1, 0, 1, 1, 1, 0, -1
    };         //+
    int[] dx2= {
      1, 1, 0, -1, -1, -1, 0, 1
    }; //+
    int[] dy2= {
      0, -1, -1, -1, 0, 1, 1, 1
    }; //+ 
    if (block_check.check_block_turn()) {
      for (i=0; i<8; i++) {                      //+
        block_buf_num[1+dy[i]][1+dx[i]] = number[block_gc_y+1+dy2[i]][block_gc_x+1+dx2[i]];  //+
      }                                      //+
      block_buf_num[1][1] = number[block_gc_y+1][block_gc_x+1];     //+
      for (y=0; y<3; y++) {
        for (x=0; x<3; x++) {
          if (field[block_gc_y+y][block_gc_x+x]==2) {
            field[block_gc_y+y][block_gc_x+x]=1;
            number[block_gc_y+y][block_gc_x+x] = 0; //+
          }
          block_buf[y][x]=block[block_type][x][2-y];
        }
      }
      for (y=0; y<3; y++) {
        for (x=0; x<3; x++) {
          if (block_buf[y][x]==1) {
            field[block_gc_y+y][block_gc_x+x]=2;
            //}                                                              //-
            number[block_gc_y+y][block_gc_x+x] = block_buf_num[y][x]; //+
          }                                                                //+
          block[block_type][y][x]=block_buf[y][x];
        }
      }
      block_mode++;
      if (block_mode==4)block_mode=0;
    }
  }

  void block_next() {
    fill(0);
    rect(370, 0, 500, 300);
    fill(#ffffff);
    text("NEXT", 400, 40);
    for (y=0; y<3; y++) {
      for (x=0; x<3; x++) {
        if (block[block_type_next][y][x]==1) {
          stroke(#f0f0f0);
          fill(#00ff00);
          rect(x*30+400, y*30+50, 30, 30);
          noStroke();
        } else {
          stroke(#f0f0f0);
          fill(#ffffff);
          rect(x*30+400, y*30+50, 30, 30);
          noStroke();
        }
      }
    }
  }
}

