Block block_c = new Block();
Field field_c = new Field();
Bonus bonus = new Bonus();
Level level_c = new Level();
Status status = new Status();
Restart restart = new Restart();
Back back=new Back();
PFont font;
boolean gameover=false;
int block_type=(int)random(7), block_type_next, block_mode=0;
int block_gc_y, block_gc_x;// grid chart
int ms, delay_t;
int point=0, point_line=0;
int y, x, i, j, time, start=0;
int bonus_count=0, score=0, bonus_k=0, line;//bomus variable
int level=1, speed=280;
public static final int H=13;                        //+
public static final int W=5;                        //+
int[][] field = new int[H+2][W+2];
int[][] number = new int[H+2][W+2];  //+
int[][][] block =
{
  {
    {
      0, 0, 0
    }
    , 
    {
      1, 1, 0
    }
    , 
    {
      0, 1, 0
    }
  }
  , 
  {
    {
      0, 0, 0
    }
    , 
    {
      0, 1, 0
    }
    , 
    {
      0, 1, 0
    }
  }
  , 
  {
    {
      0, 0, 0
    }
    , 
    {
      0, 1, 1
    }
    , 
    {
      0, 0, 0
    }
  }
  , 
  {
    {
      0, 0, 0
    }
    , 
    {
      0, 1, 0
    }
    , 
    {
      0, 0, 0
    }
    ,
  }
  , 
  {
    {
      0, 1, 0
    }
    , 
    {
      0, 1, 1
    }
    , 
    {
      0, 0, 0
    }
  }
  , 
  {
    {
      0, 0, 0
    }
    , 
    {
      0, 1, 0
    }
    , 
    {
      0, 0, 0
    }
  }
  , 
  {
    {
      0, 1, 0
    }
    , 
    {
      0, 1, 0
    }
    , 
    {
      0, 1, 0
    }
  }
};

void setup() {
  frameRate(360);
  size(600, 700);
  background(#cccccc);
  noStroke();
  for (y=0; y<H+2; y++) {
    for (x=0; x<W+2; x++) {
      if (x==0||x==W+1||y==0||y==H+1) {
        field[y][x]=0;
      } 
      else {
        field[y][x]=1;
      }
    }
  }
  font=loadFont("ArialMT-32.vlw");
  textFont(font, 32);
}

void draw() {
  noStroke();
  if (start==0) {
    display_gamestart();
  } 
  else {
    for (x=1; x<W+1; x++) if (field[4][x]==3) gameover=true;
    time++;                                               //-
    if (time%speed==0&&!gameover) {                           //+
      if (!block_c.block_check.create_block()) block_c.move_block();
      field_c.draw_field();
      field_c.clear_lines();
      level_c.level_decition();

      //message_box();
    } 
    else if (gameover) {
      display_gameover();
      noLoop();
    }
  }
}

void keyPressed() {
  if (key==CODED&&!gameover) {
    if (keyCode==UP) {
      block_c.turn_block();
      field_c.draw_field();
    } 
    else if (keyCode==DOWN) {
      block_c.move_block_down();
      field_c.draw_field();
    } 
    else if (keyCode==RIGHT) {
      block_c.move_block_right();
      field_c.draw_field();
    } 
    else if (keyCode==LEFT) {
      block_c.move_block_left();
      field_c.draw_field();
    }
  } 
  else if (!gameover) {
    if (key==ENTER) {
      start=1;
    }
    if (key==' ') {
      if (bonus_count>0) {
        bonus.bonus_clear();
        field_c.draw_field();
        bonus_count--;
      }
    } 
    else if (key=='1') {
      if (bonus_k>0) {
        bonus.bonus_clear_number1(1);
        field_c.draw_field();
        bonus_k--;
      }
    } 
    else if (key=='2') {
      if (bonus_k>0) {
        bonus.bonus_clear_number1(2);
        field_c.draw_field();
        bonus_k--;
      }
    } 
    else if (key=='3') {
      if (bonus_k>0) {
        bonus.bonus_clear_number1(3);
        field_c.draw_field();
        bonus_k--;
      }
    }
  } 
  else if (gameover) {
    if (key=='r') {
      restart.reset();
    }
  }
}

void display_gameover() {
  rect(70, 310, 450, 120);
  textAlign(CENTER);
  textSize(40);
  fill(#ffffff);
  background(0);
  text("Gameover!!", 300, 300);
  text("SCORE", 250, 350);
  text(nf(score, 4), 400, 350);
  text("Restart -> press R key!", 290, 400);
  fill(#000000);
}
void display_gamestart() {
  back.start();
  textAlign(CENTER);
  textSize(40);
  fill(#ffa500);
  text("Please Press Enter!", 300, 400);
  text("Game Start!!", 300, 470);
}

