import processing.core.*; 
import processing.xml.*; 

import java.applet.*; 
import java.awt.Dimension; 
import java.awt.Frame; 
import java.awt.event.MouseEvent; 
import java.awt.event.KeyEvent; 
import java.awt.event.FocusEvent; 
import java.awt.Image; 
import java.io.*; 
import java.net.*; 
import java.text.*; 
import java.util.*; 
import java.util.zip.*; 
import java.util.regex.*; 

public class number_tetris_16 extends PApplet {

Block block_c = new Block();
Field field_c = new Field();
Bonus bonus = new Bonus();
Level level_c = new Level();
Status status = new Status();
Restart restart = new Restart();
Back back=new Back();
PFont font;
boolean gameover=false;
int block_type=(int)random(7), block_type_next, block_mode=0;
int block_gc_y, block_gc_x;// grid chart
int ms, delay_t;
int point=0, point_line=0;
int y, x, i, j, time, start=0;
int bonus_count=0, score=0, bonus_k=0, line;//bomus variable
int level=1, speed=280;
public static final int H=13;                        //+
public static final int W=5;                        //+
int[][] field = new int[H+2][W+2];
int[][] number = new int[H+2][W+2];  //+
int[][][] block =
{
  {
    {
      0, 0, 0
    }
    , 
    {
      1, 1, 0
    }
    , 
    {
      0, 1, 0
    }
  }
  , 
  {
    {
      0, 0, 0
    }
    , 
    {
      0, 1, 0
    }
    , 
    {
      0, 1, 0
    }
  }
  , 
  {
    {
      0, 0, 0
    }
    , 
    {
      0, 1, 1
    }
    , 
    {
      0, 0, 0
    }
  }
  , 
  {
    {
      0, 0, 0
    }
    , 
    {
      0, 1, 0
    }
    , 
    {
      0, 0, 0
    }
    ,
  }
  , 
  {
    {
      0, 1, 0
    }
    , 
    {
      0, 1, 1
    }
    , 
    {
      0, 0, 0
    }
  }
  , 
  {
    {
      0, 0, 0
    }
    , 
    {
      0, 1, 0
    }
    , 
    {
      0, 0, 0
    }
  }
  , 
  {
    {
      0, 1, 0
    }
    , 
    {
      0, 1, 0
    }
    , 
    {
      0, 1, 0
    }
  }
};

public void setup() {
  frameRate(360);
  size(600, 700);
  background(0xffcccccc);
  noStroke();
  for (y=0; y<H+2; y++) {
    for (x=0; x<W+2; x++) {
      if (x==0||x==W+1||y==0||y==H+1) {
        field[y][x]=0;
      } 
      else {
        field[y][x]=1;
      }
    }
  }
  font=loadFont("ArialMT-32.vlw");
  textFont(font, 32);
}

public void draw() {
  noStroke();
  if (start==0) {
    display_gamestart();
  } 
  else {
    for (x=1; x<W+1; x++) if (field[4][x]==3) gameover=true;
    time++;                                               //-
    if (time%speed==0&&!gameover) {                           //+
      if (!block_c.block_check.create_block()) block_c.move_block();
      field_c.draw_field();
      field_c.clear_lines();
      level_c.level_decition();

      //message_box();
    } 
    else if (gameover) {
      display_gameover();
      noLoop();
    }
  }
}

public void keyPressed() {
  if (key==CODED&&!gameover) {
    if (keyCode==UP) {
      block_c.turn_block();
      field_c.draw_field();
    } 
    else if (keyCode==DOWN) {
      block_c.move_block_down();
      field_c.draw_field();
    } 
    else if (keyCode==RIGHT) {
      block_c.move_block_right();
      field_c.draw_field();
    } 
    else if (keyCode==LEFT) {
      block_c.move_block_left();
      field_c.draw_field();
    }
  } 
  else if (!gameover) {
    if (key==ENTER) {
      start=1;
    }
    if (key==' ') {
      if (bonus_count>0) {
        bonus.bonus_clear();
        field_c.draw_field();
        bonus_count--;
      }
    } 
    else if (key=='1') {
      if (bonus_k>0) {
        bonus.bonus_clear_number1(1);
        field_c.draw_field();
        bonus_k--;
      }
    } 
    else if (key=='2') {
      if (bonus_k>0) {
        bonus.bonus_clear_number1(2);
        field_c.draw_field();
        bonus_k--;
      }
    } 
    else if (key=='3') {
      if (bonus_k>0) {
        bonus.bonus_clear_number1(3);
        field_c.draw_field();
        bonus_k--;
      }
    }
  } 
  else if (gameover) {
    if (key=='r') {
      restart.reset();
    }
  }
}

public void display_gameover() {
  rect(70, 310, 450, 120);
  textAlign(CENTER);
  textSize(40);
  fill(0xffffffff);
  background(0);
  text("Gameover!!", 300, 300);
  text("SCORE", 250, 350);
  text(nf(score, 4), 400, 350);
  text("Restart -> press R key!", 290, 400);
  fill(0xff000000);
}
public void display_gamestart() {
  back.start();
  textAlign(CENTER);
  textSize(40);
  fill(0xffffa500);
  text("Please Press Enter!", 300, 400);
  text("Game Start!!", 300, 470);
}

class Back {
  public void start () {
    size(600, 700);
    background(0);
    smooth();

    fill(0, 0, 200);
    stroke(255);
    strokeWeight(2);

    int x = 20, y = 20;
    int g = 10, b = 170;

    for (int i = 1; i < 8; i++) {
      fill(0, g, b);
      // 1
      for (int j = 1; j < 4; j++) {
        if ((j == 1 && (i == 1 || i == 7)) || (j == 2) || (j == 3 && i == 7)) {
          rect(x * j, y * i + 100, 20, 20);
        }
      }
      // 0
      for (int j = 5; j < 9; j++) {
        if (!((j == 6 || j == 7) && (i > 1 && i < 7))) {
          rect(x * j, y * i + 100, 20, 20);
        }
      }
      // T
      for (int j = 10; j < 15; j++) {
        if (i == 1 || j == 12) {
          rect(x * j, y * i + 100, 20, 20);
        }
      }
      // R
      for (int j = 16; j < 20; j++) {
        if ((j == 16) || (j == 17 && (i == 1 || i == 4)) || (j == 18 && (i == 1 || i == 4 || i == 5)) || (j == 19 && i != 5)) {
          rect(x * j, y * i + 100, 20, 20);
        }
      }
      // I
      for (int j = 21; j < 24; j++) {
        if ((j == 22) || (i == 1 || i == 7)) {
          rect(x * j, y * i + 100, 20, 20);
        }
      }
      // S
      for (int j = 25; j < 29; j++) {
        if (!((j > 25 && j < 29) && (i == 2 || i == 3) || (j > 24 && j < 28) && (i == 5 || i == 6))) {
          rect(x * j, y * i + 100, 20, 20);
        }
      }
      g += 20;
      b += 10;
    }
  }
}

class Block {
  Block_check block_check = new Block_check();

  public void move_block() { 
    if (block_check.check_block_down()) {
      block_gc_y++;
      for (y=H; y>0; y--) {
        for (x=W; x>0; x--) {
          if (field[y][x]==2) {
            field[y+1][x]=2;
            number[y+1][x] = number[y][x]; //+
            field[y][x]=1;
            number[y][x] = 0; //+
          }
        }
      }
    } else {
      field_c.draw_field();
      lock_block();
    }
  }

  public void move_block_down() { 
    boolean flag=false;
    if (block_check.check_block_down()) {
      for (y=0; y<H+2; y++) {
        for (x=0; x<W+2; x++) {
          if (field[y][x]==2) {
            flag=true;
            break;
          }
        }
        if (flag)break;
      }
      block_gc_y++;
      for (y=H; y>0; y--) {
        for (x=W; x>0; x--) {
          if (field[y][x]==2) {
            field[y+1][x]=2;
            number[y+1][x] = number[y][x]; //+
            field[y][x]=1;
            number[y][x] = 0; //+
          }
        }
      }
    }
  }

  public void move_block_right() { 
    if (block_check.check_block_right()) {
      block_gc_x++;
      for (y=H; y>0; y--) {
        for (x=W; x>0; x--) {
          if (field[y][x]==2) {
            field[y][x+1]=2;
            number[y][x+1] = number[y][x];  //+
            field[y][x]=1;
            number[y][x] = 0;
          }
        }
      }
    }
  }

  public void move_block_left() {
    if (block_check.check_block_left()) {
      block_gc_x--;
      for (y=H; y>0; y--) {
        for (x=1; x<W+1; x++) {
          if (field[y][x]==2) {
            field[y][x]=1;
            number[y][x-1] = number[y][x]; //+
            field[y][x-1]=2;
            number[y][x] = 0; //+
          }
        }
      }
    }
  }

  public void lock_block() {
    for (y=0; y<H+2; y++) {
      for (x=0; x<W+2; x++) {
        if (field[y][x]==2) {
          field[y][x]=3;
        }
      }
    }
    int k = H * W;
    while (k>0) {
      for (y=H; y>0; y--) {
        for (x=W; x>0; x--) {
          if (field[y][x]==3 && field[y+1][x]==1) {                //change+ 7/20
            field[y+1][x]=3;
            number[y+1][x] = number[y][x]; //+
            field[y][x]=1;
            number[y][x] = 0; //+
          }
        }
      }
      k--;
    }
  }

  public void turn_block() {
    int[][] block_buf=new int [3][3];
    int[][] block_buf_num = new int[3][3];  //+
    int[] dx = {
      0, -1, -1, -1, 0, 1, 1, 1
    };         //+
    int[] dy = {
      -1, -1, 0, 1, 1, 1, 0, -1
    };         //+
    int[] dx2= {
      1, 1, 0, -1, -1, -1, 0, 1
    }; //+
    int[] dy2= {
      0, -1, -1, -1, 0, 1, 1, 1
    }; //+ 
    if (block_check.check_block_turn()) {
      for (i=0; i<8; i++) {                      //+
        block_buf_num[1+dy[i]][1+dx[i]] = number[block_gc_y+1+dy2[i]][block_gc_x+1+dx2[i]];  //+
      }                                      //+
      block_buf_num[1][1] = number[block_gc_y+1][block_gc_x+1];     //+
      for (y=0; y<3; y++) {
        for (x=0; x<3; x++) {
          if (field[block_gc_y+y][block_gc_x+x]==2) {
            field[block_gc_y+y][block_gc_x+x]=1;
            number[block_gc_y+y][block_gc_x+x] = 0; //+
          }
          block_buf[y][x]=block[block_type][x][2-y];
        }
      }
      for (y=0; y<3; y++) {
        for (x=0; x<3; x++) {
          if (block_buf[y][x]==1) {
            field[block_gc_y+y][block_gc_x+x]=2;
            //}                                                              //-
            number[block_gc_y+y][block_gc_x+x] = block_buf_num[y][x]; //+
          }                                                                //+
          block[block_type][y][x]=block_buf[y][x];
        }
      }
      block_mode++;
      if (block_mode==4)block_mode=0;
    }
  }

  public void block_next() {
    fill(0);
    rect(370, 0, 500, 300);
    fill(0xffffffff);
    text("NEXT", 400, 40);
    for (y=0; y<3; y++) {
      for (x=0; x<3; x++) {
        if (block[block_type_next][y][x]==1) {
          stroke(0xfff0f0f0);
          fill(0xff00ff00);
          rect(x*30+400, y*30+50, 30, 30);
          noStroke();
        } else {
          stroke(0xfff0f0f0);
          fill(0xffffffff);
          rect(x*30+400, y*30+50, 30, 30);
          noStroke();
        }
      }
    }
  }
}

class Block_check {

  public boolean create_block() {
    for (y=1; y<H+1; y++) {
      for (x=1; x<W+1; x++) {
        if (field[y][x]==2)return false;//flag=false;
      }
    }
    block_type=block_type_next;
    block_type_next=(int)random(7);
    block_gc_y=1;
    block_gc_x=W/2;
    block_mode=0;
    for (y=0; y<3; y++) {
      for (x=0; x<3; x++) {
        if (block[block_type][y][x]==1) {
          field[y+1][x+W/2]=2;
          number[y+1][x+W/2] = (int)random(1, 4); //+
        }
      }
    }
    return true;
  }

  public boolean check_block_down() {
    for (y=H+1; y>=0; y--) {
      for (x=W+1; x>=0; x--) {
        if (field[y][x]==2) {
          if (field[y+1][x]==3||field[y+1][x]==0)return false;
        }
      }
    }
    return true;
  }

  public boolean check_block_right() {
    for (y=H+1; y>=0; y--) {
      for (x=W+1; x>=0; x--) {
        if (field[y][x]==2) {
          if (field[y][x+1]==3||field[y][x+1]==0)return false;
        }
      }
    }
    return true;
  }

  public boolean check_block_left() {
    for (y=H+1; y>=0; y--) {
      for (x=W+1; x>=0; x--) {
        if (field[y][x]==2) {
          if (field[y][x-1]==3||field[y][x-1]==0)return false;
        }
      }
    }
    return true;
  }

  public boolean check_block_turn() {
    int count=0;
    for (y=1; y<H+1; y++) {
      for (x=1; x<W+1; x++) {
        if (field[y][x]==2) count++;
      }
    }
    if (count==0) {
      return false;
    }
    for (y=0; y<3; y++) {
      for (x=0; x<3; x++) {
        if (block[block_type][x][2-y]==1
          &&field[block_gc_y+y][block_gc_x+x]==3
          ||field[block_gc_y+y][block_gc_x+x]==0)return false;
      }
    }
    return true;
  }

  /*
boolean check_line_down(){
   int line=0;
   for(y=H+1;y>=0;y--){
   for(x=1;x<W+1;x++){
   if(field[y][x]==3){
   if(field[y+1][x]==1){
   for(x=1;x<W+1;x++)line+=field[y+1][x];   //change field -> number
   if(line==W){
   line=0;
   return true;
   }
   else{
   line=0;
   return false;
   }
   }
   }
   }
   }
   return false;
   }
   */
}

class Bonus {
  public void bonus_clear() {
    y=13;
    for (x=1; x<6; x++) {
      field[y][x]=1;
      number[y][x]=0;
    }
    for (y=H+1; y>0; y--) {
      for (x=1; x<6; x++) {
        if (field[y][x]==1) {
          if (field[y-1][x]==3) {
            field[y-1][x]=1;
            field[y][x]=3;
            number[y][x]=number[y-1][x];
            number[y-1][x]=0;
          }
        }
      }
    }
  }

  public void bonus_clear_number1(int t) {
    for (x=1; x<6; x++) {
      for (y=1; y<14; y++) {
        if (number[y][x]==t) {
          field[y][x]=1;
          number[y][x]=0;
        }
      }
    }
    for (line=0; line<14; line++) {
      for (y=H+1; y>0; y--) {
        for (x=1; x<6; x++) {
          if (field[y][x]==1) {
            if (field[y-1][x]==3||field[y-1][x]==2) {
              field[y-1][x]=1;
              field[y][x]=3;
              number[y][x]=number[y-1][x];
              number[y-1][x]=0;
            }
          }
        }
      }
    }
    /*  for (y=H+1; y>0; y--) {
     for (x=1; x<6; x++) {
     if (field[y][x]==1) {
     if (field[y-1][x]==2) {
     field[y-1][x]=1;
     field[y][x]=2;
     number[y][x]=number[y-1][x];
     number[y-1][x]=0;
     }
     }
     }
     }*/
  }
}

class Field {

  public void draw_field() {
    background(0xff00C121);
    strokeWeight(1.5f);
    for (y=0; y<H+2; y++) {
      for (x=0; x<W+2; x++) {
        if (field[y][x]==0) {
          fill(0xff00C121);
          if (y==0) {
            rect(x*45+20, y*45+20, 45, 20);
          } else {
            rect(x*45+20, (y-1)*45+40, 45, 45);
          }
        } else if (field[y][x]==1) {
          stroke(0xfff0f0f0);
          fill(0xffffffff);
          if (y==0) {
            rect(x*45+20, y*45+20, 45, 20);
          } else {
            rect(x*45+20, (y-1)*45+40, 45, 45);
          }
          noStroke();
        } else if (field[y][x]==2 && number[y][x]!=0) {
          stroke(0xfff0f0f0);
          fill(0xffffff00);
          if (y==0) {
            rect(x*45+20, y*45+20, 45, 20);
          } else {
            rect(x*45+20, (y-1)*45+40, 45, 45);
          }
          fill(0);
          text(number[y][x], x*45+35, y*45+30); //+
          noStroke();
        } else if (field[y][x]==3 && number[y][x]!=0) {
          stroke(0xfff0f0f0);
          fill(0xffff0000);
          if (y==0) {
            rect(x*45+20, y*45+20, 45, 20);
          } else {
            rect(x*45+20, (y-1)*45+40, 45, 45);
          }
          fill(0);
          text(number[y][x], x*45+35, y*45+30); //+
          noStroke();
        }
      }
    }
    strokeWeight(2);
    stroke(0);
    line(20+45, 40+45*3, 20+45*(W+1), 40+45*3);
    //strokeWeight(1.5);
    //stroke(#f0f0f0);
    status.express();
    noStroke();
  }

  public void clear_lines() {
    int line_x=0, line_y=0, line_all_x=0, line_all_y=0;
    int[] line_gc_y=new int [H];       //teisuuni
    int[] line_gc_x=new int [W];
    int[] line_del_y =new int [W];     //number of deleted top y 
    int count_line_x=0, count_line_y=0;
    boolean flag=false;
    for (y=1; y<H+1; y++) {
      for (x=1; x<W+1; x++) {
        line_all_y += field[y][x];    //+ change 
        if (field[y][x] == 3) {       //+ 
          line_y+=number[y][x];      //+
        }
      }
      if (line_y==10 && line_all_y==3*W) {            //change  30 -> 10  + line_all
        flag=true;
        for (x=1; x<W+1; x++) {
          field[y][x]=1;
          number[y][x] = 0;                    //+
        }
        line_gc_y[count_line_y++]=y;
      }
      line_y=0;
      line_all_y = 0;
    }

    for (x=1; x<W+1; x++) {            //tate^
      for (y=1; y<=H+1-W; y++) {
        for (j=0; j<W; j++) {
          line_all_x += field[y+j][x];    //+ change 
          if (field[y+j][x] == 3) {       //+ 
            line_x+=number[y+j][x];      //+
          }
        }
        if (line_x==10 && line_all_x==3*W) break;
        line_x=0;
        line_all_x = 0;
      }
      if (line_x==10 && line_all_x==3*W) {            //change  30 -> 10  + line_all
        flag=true;
        line_del_y[count_line_x] = y;            
        for (i=y; i<y+W; i++) {
          field[i][x]=1;
          //number[y][x] = 0;                    //+
        }
        line_gc_x[count_line_x++]=x;
        break;
      }
      //line_x=0;
      //line_all_x = 0;
    }                                 //tate^

    if (flag) {
      for (i=0; i<=count_line_y; i++) {
        for (y=line_gc_y[i]; y>1; y--) {
          for (x=1; x<W+1; x++) {
            if (field[y][x]==3) {
              field[y][x]=1;
              number[y+1][x] = number[y][x];       //+
              field[y+1][x]=3;
              number[y][x] = 0;                    //+
            }
          }
        }
      }

      for (i=0; i<=count_line_x; i++) {           //tate^
        for (j=0; j<W; j++) {
          x = line_gc_x[i];
          for (y=line_del_y[i]+j; y>1; y--) {
            if (field[y][x]==3) {
              field[y][x]=1;
              number[y+1][x] = number[y][x];       //+
              field[y+1][x]=3;
              number[y][x] = 0;                    //+
            }
          }
        }
      }                                       //tate^
      status.score_cast();
      /*
      if (count_line==1)point+=count_line*10;
       else if (count_line>1&&count_line<4)point+=count_line*20;
       else if (count_line==4)point+=100;
       point_line+=count_line;
       */
      draw_field();
    }
  }
}

class Level {
  public void level_decition() {
    if (level==1) {
      speed=260;
    }
    if (level==2) {
      speed=240;
    }
    if (level==3) {
      speed=220;
    }
    if (level==4) {
      speed=200;
    }
  }
}

class Restart {
  public void reset() {
    bonus_count=0; 
    score=0; 
    bonus_k=0; 
    //line;//bomus variable
    level=1; 
    speed=280;
    block_gc_y=0; 
    block_gc_x=0;// grid chart
    gameover=false;
    point=0; 
    point_line=0;
    font=loadFont("ArialMT-32.vlw");
    textFont(font, 32);
    for (y=0; y<H+2; y++) {
      for (x=0; x<W+2; x++) {
        if (x==0||x==W+1||y==0||y==H+1) {
          field[y][x]=0;
          number[y][x]=0;
        } 
        else {
          field[y][x]=1;
          number[y][x]=0;
        }
      }
    }
    loop();
  }
}

class Status {
  public void express() {
    fill(0);
    font=loadFont("MonotypeCorsiva-48.vlw");
    textFont(font, 32);
    textSize(32);
    text("Level :", 420+10, 320+140);
    text(nf(level, 1), 470, 320+140);
    text("Clearbonus", 420+20, 375+125);
    text("Clearline :", 400+30, 400+125);
    text(nf(bonus_count, 2), 500+20, 400+125);
    text("NumberClear(1,2,3) :", 400+20, 430+120);
    text(nf(bonus_k, 1), 550, 430+120);
    text("Score :", 400, 460+140);
    text(nf(score, 4), 470, 460+140);
    font=loadFont("ArialMT-32.vlw");
    textFont(font, 32);
  }
  public void score_cast() {
    score=score+10;
    if (score%70==0) {
      bonus_count++;
      if (level<4) {
        level++;
      }
      if (score%140==0) {
        bonus_k++;
      }
    }
  }
}

  static public void main(String args[]) {
    PApplet.main(new String[] { "--bgcolor=#F0F0F0", "number_tetris_16" });
  }
}
